/*
 * This file is part of the LibreOffice project.
 *
 * Based on LLVM/Clang.
 *
 * This file is distributed under the University of Illinois Open Source
 * License. See LICENSE.TXT for details.
 *
 */

#ifndef CREATEINSTANCECHECK_H
#define CREATEINSTANCECHECK_H

#include <clang/AST/RecursiveASTVisitor.h>

using namespace clang;

namespace loplugin
{

typedef std::vector< const Stmt* > StmtParents;

class CreateInstanceCheck
    : public RecursiveASTVisitor< CreateInstanceCheck >
    {
    public:
        explicit CreateInstanceCheck( ASTContext& context );
        void run();
        bool VisitCXXMemberCallExpr( CXXMemberCallExpr* expression );
    private:
        /// If the expression is a (constant) string, return it.
        std::string getStringFromExpression( const Expr* expression ) const;
        ASTContext& context;
    };

} // namespace

#endif // CREATEINSTANCECHECK_H
